return

//this test doesn't work yet because the peers need to transmit
//and ID somehow...

var GossipQuery = require('../')
var pull = require('pull-stream')
var net = require('net')
var tape = require('tape')
var toPull = require('stream-to-pull-stream')
var JSONDL = require('pull-json-doubleline')

function toAddress (obj) {
  return obj.address + ':' + obj.port
}

function fromAddress (str) {
  var i = str.lastIndexOf(':')
  console.log('fromAddress', str, i, {
    host: str.substring(0, i),
    port: +str.substring(i+1)
  })
  return {
    host: str.substring(0, i),
    port: +str.substring(i+1)
  }
}

function GQ (store, id) {
  var gq = GossipQuery({
    check: function (key, cb) { cb(null, store[key]) },
    process: function (key, value, cb) { cb(null, value) },
    isQuery: function (key) { return true },
    isResponse: function (value) { return null != value  }
  })

  function onConnect(stream) {
    var _id = toAddress(stream.address())
    console.log('onConnect', gq.id, _id)
    stream = toPull(stream)
    pull(
      stream,
      JSONDL.parse(),
      pull.through(console.log),
      gq.createStream(_id),
      pull.through(console.log),
      JSONDL.stringify(),
      stream
    )
  }

  gq.server = net.createServer(onConnect).listen()
  gq.id = toAddress(gq.server.address())
  gq.connect = function (addr) {
    addr = fromAddress(addr)
    onConnect(net.connect(addr.port, addr.host))
  }

  return gq
}

function connect(a, b) {
  a.connect(b.id)
//  var A = a.createStream(b.id), B = b.createStream(a.id)
//  pull(A, B, A)
}

tape('simple', function (t) {

  var g1 = GQ({foo:'baz'})
  var g2 = GQ({})

  connect(g1, g2)

  g2.query('foo', function (err, value) {
    t.equal(value, 'baz')
    g1.server.close()
    g2.server.close()
    t.end()
  })

})
return
tape('double', function (t) {

  var g1 = GQ({foo:'baz'}, 1)
  var g2 = GQ({}, 2)
  var g3 = GQ({}, 3)

  connect(g1, g2)
  connect(g2, g3)

  g3.query('foo', function (err, value) {
    t.equal(value, 'baz')
    g1.server.close()
    g2.server.close()
    g3.server.close()
    t.end()
  })

  console.log(g1.state)
  console.log(g2.state)
  console.log(g3.state)

})

tape('loop', function (t) {

  var g1 = GQ({foo:'baz'}, 1)
  var g2 = GQ({}, 2)
  var g3 = GQ({}, 3)

  connect(g1, g2)
  connect(g2, g3)
  connect(g1, g3)

  g3.query('foo', function (err, value) {
    t.equal(value, 'baz')
    g1.server.close()
    g2.server.close()
    g3.server.close()
    t.end()
  })

  console.log(g1.state)
  console.log(g2.state)
  console.log(g3.state)

})

tape('empty loop', function (t) {

  var g1 = GQ({}, 1)
  var g2 = GQ({}, 2)
  var g3 = GQ({}, 3)

  connect(g1, g2)
  connect(g2, g3)
  connect(g1, g3)

  g3.query('foo', function (err, value) {
    t.equal(value, 'baz')
    g1.server.close()
    g2.server.close()
    g3.server.close()
    t.end()
  })

  //when we connect a 4th peer, it will get queried
  //and broadcast it's answer
  var g4 = GQ({foo: 'baz'}, 4)
  connect(g1, g4)

})















